#include <Snek.h>

#include <gamma.h>
#include <RGBmatrixPanel.h>


Snek gameSnek;
float screenRefreshTime = 250;
float timeSinceRefresh;
Vector2 foodPos(255,255);

int rainbowHue[] = {0,192,384,576,768,960,1152};


byte button1State = HIGH;
byte button2State;
byte button3State;
byte button4State;
byte button1LastState = HIGH;
byte button2LastState;
byte button3LastState;
byte button4LastState;

#define button1Pin 13
#define button2Pin 12
#define button3Pin 11
#define button4Pin 1



int newDirection;
int state = 0;
int prevState = 0;
int input = 1;
int count = 0;
int rowCount = 0;
int colorMode = 0;

#define CLK  8   // USE THIS ON ARDUINO UNO, ADAFRUIT METRO M0, etc.
//#define CLK A4 // USE THIS ON METRO M4 (not M0)
//#define CLK 11 // USE THIS ON ARDUINO MEGA
#define OE   9
#define LAT 10
#define A   A0
#define B   A1
#define C   A2
#define xPin A4
#define yPin A5

// Last parameter = 'true' enables double-buffering, for flicker-free,
// buttery smooth animation.  Note that NOTHING WILL SHOW ON THE DISPLAY
// until the first call to swapBuffers().  This is normal.
RGBmatrixPanel matrix(A, B, C, CLK, LAT, OE, false);
// Double-buffered mode consumes nearly all the RAM available on the
// Arduino Uno -- only a handful of free bytes remain.  So this code uses
// a bunch of precalculated data in tables to minimize RAM usage and speed
// things up.

#define F2(progmem_ptr) (const __FlashStringHelper *)progmem_ptr

const char str[] PROGMEM = "Snek Game";
int16_t    textX         = matrix.width(),
           textMin       = sizeof(str) * -6,
           hue           = 0;

const char endGameStr[] PROGMEM = "Score : ";
int16_t    endGametextX         = matrix.width(),
           endGametextMin       = sizeof(endGameStr) * -6,
           endGamehue           = 0;
void setup()
{
  //Serial.begin(9600);     
  gameSnek = Snek();
  matrix.begin();
  matrix.setTextWrap(false);
  gameSnek.length = 2;
  randomSeed(analogRead(A3));
  foodPos = Vector2(16,4);
  gameSnek.direction = 1;
  gameSnek.headPos = Vector2(16,6);
  matrix.fillScreen(0);
 

  
  

}

void loop()
{
    InputHandle();
	if( millis() - timeSinceRefresh >= screenRefreshTime){
        timeSinceRefresh = millis();
        if(state == 1){
            screenRefreshTime = 200;
            gameSnek.ChangeDirection(input);
            GameLoop();
            UpdateScreen();
            count++;
        }
        else if(state == 2){
            
            screenRefreshTime = 75;

            matrix.drawLine(rowCount    ,16,rowCount    ,0,matrix.ColorHSV(rainbowHue[rowCount     % 7],255,186,true));
            matrix.drawLine(rowCount - 1,16,rowCount - 1,0,matrix.ColorHSV(rainbowHue[rowCount     % 7],255,155,true));
            matrix.drawLine(rowCount - 2,16,rowCount - 2,0,matrix.ColorHSV(rainbowHue[rowCount + 1 % 7],255,124,true));
            matrix.drawLine(rowCount - 3,16,rowCount - 3,0,matrix.ColorHSV(rainbowHue[rowCount + 1 % 7],255, 93,true));
            matrix.drawLine(rowCount - 4,16,rowCount - 4,0,matrix.ColorHSV(rainbowHue[rowCount + 2 % 7],255, 62,true));
            matrix.drawLine(rowCount - 5,16,rowCount - 5,0,matrix.ColorHSV(rainbowHue[rowCount + 2 % 7],255, 31,true));
            matrix.drawLine(rowCount - 6,16,rowCount - 6,0,matrix.ColorHSV(rainbowHue[rowCount + 2 % 7],255,  0,true));
            rowCount++;
            if(rowCount >= 38){
                
                screenRefreshTime = 250;
                rowCount = 0;
                if(prevState == 1){
                    state = 3;

                }else if(prevState == 0){
                    state = 1;
                    foodPos = Vector2(16,4);
                    gameSnek.direction = 1;
                    gameSnek.headPos = Vector2(16,6);
                    matrix.fillScreen(0);
                    gameSnek.length = 1;
                    gameSnek.ded = false;
                }if(prevState == 3){
                    state = 0;
                }
            }
        }
        else if(state == 0 ){
            screenRefreshTime = 100;
            matrix.fillScreen(0);
            // Draw big scrolly text on top
            matrix.setTextColor(matrix.ColorHSV(hue, 255, 100, true));
            matrix.setCursor(textX, 5);
            matrix.print(F2(str));

            // Move text left (w/wrap), increase hue
            if((--textX) < textMin) textX = matrix.width();
            hue += 10;
            if(hue >= 1536) hue -= 1536;


        }
        else if(state == 3){
            
            screenRefreshTime = 100;
            matrix.fillScreen(0);
            // Draw big scrolly text on top
            matrix.setTextColor(matrix.ColorHSV(endGamehue, 255, 100, true));
            matrix.setCursor(endGametextX, 5);
            matrix.print(F2(endGameStr));
            matrix.print(gameSnek.length);
            // Move text left (w/wrap), increase hue
            if((--endGametextX) < endGametextMin) endGametextX = matrix.width();
            endGamehue += 7;
            if(endGamehue >= 1536) endGamehue -= 1536;
            

        }
        //setting time at beggining of loop allows for the process  to be done within the refresh time 
        //Serial.println(gameSnek.length);
        //Serial.println(gameSnek.headPos.y);
        
        
      
        
        
    }
    //Serial.print("Looping");
}
void GameLoop(){
    
    //use the snek class to deal with the movement
    gameSnek.MoveSnake();
    if(gameSnek.ded == true){
       ResetGame();
    }

    //check if the head is on top of the food
    if(foodPos == gameSnek.headPos){
       gameSnek.length++;
       SpawnFood();
    }
}

//updates screen visuals
void UpdateScreen(){
    if(state == 0){
        return;
    }
    
    matrix.fillScreen(matrix.Color333(0, 0, 0));
    if(colorMode == 1) matrix.drawPixel(foodPos.x,foodPos.y, matrix.ColorHSV(0,0,100, true));
    else if (colorMode == 0 || colorMode == 2) matrix.drawPixel(foodPos.x,foodPos.y, matrix.ColorHSV(0,255,100, true));
    
    //set pixels with foodPosCoords
    for (int i = 0; i < gameSnek.length; i++)
    {
        if(colorMode == 1) matrix.drawPixel(gameSnek.lightPos[i].x, gameSnek.lightPos[i].y, matrix.ColorHSV(rainbowHue[(count - i) % 7],255,100, true));
        else if (colorMode == 0) matrix.drawPixel(gameSnek.lightPos[i].x, gameSnek.lightPos[i].y, matrix.ColorHSV(1047,255,100, true));
        else if (colorMode == 2) matrix.drawPixel(gameSnek.lightPos[i].x, gameSnek.lightPos[i].y, matrix.ColorHSV(644,255,100, true));

    }
    
    
    
    
}


//make an interrupt so therer is less input lag
void InputHandle(){

    
    //get information from button if button press has changed then send information to snake class
  


    // 1 = N
    // 2 = E
    // 3 = S
    // 4 = W


    button1LastState = button1State;
    button1State = digitalRead(button1Pin);    

   
    
    if(button1LastState == LOW && button1State == HIGH){
        if(state == 0 ){
            state = 2;
            prevState = 0;
            rowCount = 0;
            
        } 
        else if(state == 3){
            state = 2;
            prevState = 3;
            rowCount = 0;
        }
        else if (state == 1){
            colorMode ++;
            if(colorMode > 2){
                colorMode = 0;
            }
        }

      
    }
    int xPos = analogRead(xPin);
    int yPos = analogRead(yPin);
    bool xLeftThresh = (xPos <= 200);
    bool xRightThresh = (xPos >= 800);
    bool yUpThresh = (yPos >= 800);
    bool yDownThresh = (yPos <= 200);

    
    if(xLeftThresh){
        if(yUpThresh || yDownThresh){
            return;
        }
        input = 4;
    }else if(xRightThresh){
         if(yUpThresh || yDownThresh){
            return;
        }
        input = 2;
    }else if(yUpThresh){
         if(xLeftThresh || xRightThresh){
            return;
        }
        input = 1;
    }else if(yDownThresh){
         if(xLeftThresh || xRightThresh){
            return;
        }
        input = 3;
    }
    
  
    
    
    
    //change the direction of the snek
  
}


void SpawnFood(){
    //make sure food is not spawning inside of the snake
    //do while becuase the food starts in an invalid position as it is at the same pos as the snake head 
    do
    {
      foodPos = Vector2(random(0,32),random(0,16));
    } while (CheckFood());
    

    
}

void ResetGame(){
    state = 2;
    rowCount = 0;
    prevState = 1;
    

}

bool CheckFood(){

    //check all of the snakes positions
    
    if(foodPos == gameSnek.headPos){
        return true;
    }
    //look through all of the snake positions
    for (int i = 0; i < gameSnek.length; i++)
    {
        if(foodPos == gameSnek.lightPos[i]) return true;
    }
    //if place is valid exit out of do while loop
    return false;
    
    
}
